// Dlg_Rubriki.cpp : implementation file
//

#include "stdafx.h"
#include "Rubrikator.h"
#include "Dlg_Rubriki.h"
#include "Dlg_NewRubr.h"
#include "Dlg_renameR.h"
#include "Rubr.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDlg_Rubriki dialog


CDlg_Rubriki::CDlg_Rubriki(CWnd* pParent /*=NULL*/)
	: CDialog(CDlg_Rubriki::IDD, pParent)
{
	EnableAutomation();

	//{{AFX_DATA_INIT(CDlg_Rubriki)
	m_edit1 = _T("");
	//}}AFX_DATA_INIT
}


void CDlg_Rubriki::OnFinalRelease()
{
	// When the last reference for an automation object is released
	// OnFinalRelease is called.  The base class will automatically
	// deletes the object.  Add additional cleanup required for your
	// object before calling the base class.

	CDialog::OnFinalRelease();
}

void CDlg_Rubriki::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlg_Rubriki)
	DDX_Control(pDX, IDC_LIST3, m_list2);
	DDX_Control(pDX, IDC_LIST1, m_list1);
	DDX_Control(pDX, IDC_COMBO1, m_combo1);
	DDX_Text(pDX, IDC_EDIT1, m_edit1);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDlg_Rubriki, CDialog)
	//{{AFX_MSG_MAP(CDlg_Rubriki)
	ON_BN_CLICKED(IDC_BUTTON7, On_AddRubr)
	ON_WM_CAPTURECHANGED()
	ON_WM_SHOWWINDOW()
	ON_WM_PAINT()
	ON_BN_CLICKED(IDC_BUTTON6, On_ViewRubr)
	ON_BN_CLICKED(IDC_BUTTON8, On_EditDirRubr)
	ON_BN_CLICKED(IDC_BUTTON1, On_AddFromEdit1)
	ON_BN_CLICKED(IDC_BUTTON5, On_ClearAllK)
	ON_BN_CLICKED(IDC_BUTTON9, On_DelRubr)
	ON_BN_CLICKED(IDC_BUTTON4, On_DelSel)
	ON_BN_CLICKED(IDC_BUTTON3, On_Etalon)
	ON_BN_CLICKED(IDC_BUTTON2, On_AddKeyword)
	ON_BN_CLICKED(IDC_BUTTON10, OnButton10)
	ON_CBN_SELCHANGE(IDC_COMBO1, OnSelchangeCombo1)
	ON_BN_CLICKED(IDC_BUTTON11, On_RenameRubr)
	ON_WM_MOUSEMOVE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

BEGIN_DISPATCH_MAP(CDlg_Rubriki, CDialog)
	//{{AFX_DISPATCH_MAP(CDlg_Rubriki)
		// NOTE - the ClassWizard will add and remove mapping macros here.
	//}}AFX_DISPATCH_MAP
END_DISPATCH_MAP()

// Note: we add support for IID_IDlg_Rubriki to support typesafe binding
//  from VBA.  This IID must match the GUID that is attached to the 
//  dispinterface in the .ODL file.

// {A5DA6911-0803-4FC2-8971-56C64776A872}
static const IID IID_IDlg_Rubriki =
{ 0xa5da6911, 0x803, 0x4fc2, { 0x89, 0x71, 0x56, 0xc6, 0x47, 0x76, 0xa8, 0x72 } };

BEGIN_INTERFACE_MAP(CDlg_Rubriki, CDialog)
	INTERFACE_PART(CDlg_Rubriki, IID_IDlg_Rubriki, Dispatch)
END_INTERFACE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDlg_Rubriki message handlers

void CDlg_Rubriki::On_AddRubr() 
{
	CDlg_NewRubr dlg;
	dlg.DoModal();
	
}

void CDlg_Rubriki::OnCaptureChanged(CWnd *pWnd) 
{
	// TODO: Add your message handler code here


	CDialog::OnCaptureChanged(pWnd);
}

void CDlg_Rubriki::OnShowWindow(BOOL bShow, UINT nStatus) 
{
	CDialog::OnShowWindow(bShow, nStatus);

	RR.LoadSettings("settings.dat");
	
	UpdateData(true);

	m_combo1.ResetContent();
	for (int i=0; i<RR.B.numR; i++)
		m_combo1.AddString(RR.B.rubriks[i].name);
}

void CDlg_Rubriki::OnPaint() 
{
	CPaintDC dc(this); // device context for painting
	
	// TODO: Add your message handler code here
	
	// Do not call CDialog::OnPaint() for painting messages

	UpdateData(true);

	CString y;

	if (m_combo1.GetCount()!=RR.B.numR)
	{
		RR.tmpID=-1;
		m_combo1.ResetContent();
		for (int i=0; i<RR.B.numR; i++)
			m_combo1.AddString(RR.B.rubriks[i].name);

		m_list1.ResetContent();
		m_list2.ResetContent();
		SetDlgItemText(IDC_STATIC1, "");
		SetDlgItemText(IDC_STATIC3, "  - \"\"");
	}

	//y.Format("RR.tmpID = \"%d\" %d - %d; ",RR.tmpID, m_combo1.GetCount(), RR.B.numR);
	//AfxMessageBox(y);
}

void CDlg_Rubriki::On_ViewRubr() 
{

}

//  
void CDlg_Rubriki::On_EditDirRubr() 
{
	CString y;
	int nRurb;

	if (m_combo1.GetCurSel()>=0)
	{	
		nRurb=m_combo1.GetCurSel();
		
		y=RR.NewPath();
		
		if (y!="")
		{
			SetDlgItemText(IDC_STATIC1, y);
			RR.B.rubriks[nRurb].dir=y;
			RR.SaveSettings("settings.dat");
		}
	}
}

void CDlg_Rubriki::On_AddFromEdit1() 
{
	int nRurb;
	
	UpdateData(true);
	m_edit1.MakeLower();
	if (m_combo1.GetCurSel()>=0)
	{
		if (m_edit1=="")	AfxMessageBox("   \" \"!");
		else if (m_edit1.GetLength()<3)	AfxMessageBox("       3 !");
		else if (RR.SearchProbel(m_edit1)>=0)	AfxMessageBox("     ( )!");
		else
		{
			nRurb=m_combo1.GetCurSel();

			int numW[500];
			CString * words;
			words = RR.B.rubriks[nRurb].keyword;
			
			if (RR.in_array(words,numW,m_edit1,RR.B.rubriks[nRurb].numK)==-1)
			{
				m_list1.AddString(m_edit1);

				RR.B.rubriks[nRurb].keyword[RR.B.rubriks[nRurb].numK]=m_edit1;
				RR.B.rubriks[nRurb].numK++;

				SetDlgItemText(IDC_EDIT1, "");

				RR.SaveSettings("settings.dat");
			}
			else	AfxMessageBox("       .");
		}
	}
	else AfxMessageBox("  ");
}

void CDlg_Rubriki::On_ClearAllK() 
{
	int nRurb;
	
	UpdateData(true);
	if (m_combo1.GetCurSel()>=0)
	{
		nRurb=m_combo1.GetCurSel();

		m_list1.ResetContent();
		RR.B.rubriks[nRurb].numK=0;
		RR.SaveSettings("settings.dat");
	}
}

void CDlg_Rubriki::On_DelRubr() 
{
	int nRurb, ex, i;
	CString y;
	
	UpdateData(true);
	if (m_combo1.GetCurSel()>=0)
	{
		nRurb=m_combo1.GetCurSel();
		
		y.Format("    \"%s\"?", RR.B.rubriks[nRurb].name);
		if (AfxMessageBox(y, MB_OKCANCEL )==IDOK)
		{		
			for(i=0; i<RR.B.numR-1; i++)
			{
				if (nRurb==i)	ex=1;
				
				if (ex==1)	RR.B.rubriks[i]=RR.B.rubriks[i+1];
			}
			
			RR.B.numR--;
			RR.SaveSettings("settings.dat");
			AfxMessageBox(" !");
			
			m_combo1.ResetContent();
			for (i=0; i<RR.B.numR; i++)
				m_combo1.AddString(RR.B.rubriks[i].name);
			
			m_list1.ResetContent();
			m_list2.ResetContent();
			SetDlgItemText(IDC_STATIC1, "");
			SetDlgItemText(IDC_STATIC3, "  - \"\"");
		}
	}
}

// 
void CDlg_Rubriki::On_DelSel() 
{
	int nRurb, n, ex, i;
	CString y;
	
	UpdateData(true);
	if (m_combo1.GetCurSel()>=0)
	{
		nRurb=m_combo1.GetCurSel();

		if (m_list1.GetCurSel()>=0)
		{
			n=m_list1.GetCurSel();
			
			m_list1.ResetContent();
			for(i=0; i<RR.B.rubriks[nRurb].numK-1; i++)
			{
				if (n==i)	ex=1;
				
				if (ex==1)	RR.B.rubriks[nRurb].keyword[i]=RR.B.rubriks[nRurb].keyword[i+1];

				m_list1.AddString(RR.B.rubriks[nRurb].keyword[i]);
			}

			m_list1.SetCurSel(n-1);
			
			RR.B.rubriks[nRurb].numK--;
			RR.SaveSettings("settings.dat");
		}	
	}
}

void CDlg_Rubriki::On_Etalon() 
{
	CString file, y;
	CFileDialog DlgLoad(TRUE,NULL,NULL,NULL,(LPCSTR)"Text Files (*.txt;*.doc) |*.txt;*.doc;|||");
	CString words[100000];
	int numW[100000], countW=0, i;
	int sum=0,sr=0, s=1;

	if(DlgLoad.DoModal()!=IDOK) return;
	
	file=DlgLoad.GetPathName();
	int type=RR.DocumentType(file);

	if (type==0)
	{
		countW=RR.LoadFromDOC(file, words, numW);
	}
	else if (type==1) 
	{
		countW=RR.LoadFromTXT(file, words, numW);
	}
	else AfxMessageBox("  ...");


	m_list2.ResetContent();	
	if (countW>0)
	{
		sum=0; sr=0; s=1;
		for (i=0; i<countW; i++)
		{
			if (numW[i]>1)	
			{
				sum+=numW[i];
				s++;
			}
		}
		sr=(int)sum/s;

		m_list2.ResetContent();
		for (i=0; i<countW; i++)
		{
			if (numW[i]>1 && i<300)
			{
				//y.Format("%d. %d - %s", i, numW[i], words[i]);
				y.Format("%s", words[i]);
				m_list2.AddString(y);
			}
		}
	}

}

// .      -.
void CDlg_Rubriki::On_AddKeyword() 
{
	int nRurb;
	CString y;
	
	UpdateData(true);
	
	if (m_combo1.GetCurSel()>=0 && m_list2.GetCurSel()>=0)
	{
		nRurb=m_combo1.GetCurSel();
		
		m_list2.GetText(m_list2.GetCurSel(), y);
		
		int numW[500];
		CString * words;
		words = RR.B.rubriks[nRurb].keyword;
		
		if (RR.in_array(words,numW,y,RR.B.rubriks[nRurb].numK)==-1)
		{
			m_list1.AddString(y);
			
			RR.B.rubriks[nRurb].keyword[RR.B.rubriks[nRurb].numK]=y;
			RR.B.rubriks[nRurb].numK++;
			
			RR.SaveSettings("settings.dat");
		}
		else	AfxMessageBox("       .");
	}
	else AfxMessageBox("  ");
}

//   -  .
void CDlg_Rubriki::OnButton10() 
{
	int nRurb;
	CString y;
	
	UpdateData(true);
	
	if (m_combo1.GetCurSel()>=0)
	{
		nRurb=m_combo1.GetCurSel();
		
		int numW[500];
		CString * words;
		
		for (int i=0; i<m_list2.GetCount(); i++)
		{
			m_list2.GetText(i, y);
			
			words = RR.B.rubriks[nRurb].keyword;
			
			if (RR.in_array(words,numW,y,RR.B.rubriks[nRurb].numK)==-1)
			{
				m_list1.AddString(y);
				
				RR.B.rubriks[nRurb].keyword[RR.B.rubriks[nRurb].numK]=y;
				RR.B.rubriks[nRurb].numK++;
			}
		}
		
		RR.SaveSettings("settings.dat");
	}
	else AfxMessageBox("  ");
}

void CDlg_Rubriki::OnSelchangeCombo1() 
{
	int nRurb, i;
	CString y;
	
	if (m_combo1.GetCurSel()>=0)
	{
		nRurb=m_combo1.GetCurSel();
		
		SetDlgItemText(IDC_STATIC1, RR.B.rubriks[nRurb].dir);
		
		y.Format("  - \"%s\"",RR.B.rubriks[nRurb].name);
		SetDlgItemText(IDC_STATIC3, y);
		
		m_list1.ResetContent();
		for (i=0; i<RR.B.rubriks[nRurb].numK; i++)
		{
			y.Format("%s", RR.B.rubriks[nRurb].keyword[i]);
			m_list1.AddString(y);
		}
	}
}

void CDlg_Rubriki::On_RenameRubr() 
{
	CString y;
	if (m_combo1.GetCurSel()>=0)
	{
		RR.tmpID=m_combo1.GetCurSel();
		CDlg_renameR dlgR;
		dlgR.DoModal();	
	}
}

BOOL CDlg_Rubriki::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CDlg_Rubriki::OnMouseMove(UINT nFlags, CPoint point) 
{
	CString y;
	int sel, i;
	
	//     -    ""
	if (m_combo1.GetCount() < RR.B.numR || (RR.tmpID==-2 || RR.tmpID>=0))
	{
		m_combo1.ResetContent();
		for (i=0; i<RR.B.numR; i++)
			m_combo1.AddString(RR.B.rubriks[i].name);
		
		if (RR.tmpID>=0)	sel = RR.tmpID;
		else				sel = RR.B.numR-1;
		
		m_combo1.SetCurSel(sel);
		
		SetDlgItemText(IDC_STATIC1, RR.B.rubriks[sel].dir);
		
		y.Format("  - \"%s\"",RR.B.rubriks[sel].name);
		SetDlgItemText(IDC_STATIC3, y);
		
		m_list1.ResetContent();
		for (i=0; i<RR.B.rubriks[sel].numK; i++)
		{
			m_list1.AddString(RR.B.rubriks[sel].keyword[i]);
		}
		
		RR.tmpID=-1;
	}
	
	CDialog::OnMouseMove(nFlags, point);
}
