// Dlg_NewRubr.cpp : implementation file
//

#include "stdafx.h"
#include "Rubrikator.h"
#include "Dlg_NewRubr.h"
#include "afxwin.h"
#include "Rubr.h"
#include "Dlg_Rubriki.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDlg_NewRubr dialog


CDlg_NewRubr::CDlg_NewRubr(CWnd* pParent /*=NULL*/)
	: CDialog(CDlg_NewRubr::IDD, pParent)
{
	EnableAutomation();

	//{{AFX_DATA_INIT(CDlg_NewRubr)
	m_edit1 = _T("");
	m_edit2 = _T("");
	//}}AFX_DATA_INIT
}


void CDlg_NewRubr::OnFinalRelease()
{
	// When the last reference for an automation object is released
	// OnFinalRelease is called.  The base class will automatically
	// deletes the object.  Add additional cleanup required for your
	// object before calling the base class.

	CDialog::OnFinalRelease();
}

void CDlg_NewRubr::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlg_NewRubr)
	DDX_Text(pDX, IDC_EDIT1, m_edit1);
	DDX_Text(pDX, IDC_EDIT2, m_edit2);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDlg_NewRubr, CDialog)
	//{{AFX_MSG_MAP(CDlg_NewRubr)
	ON_BN_CLICKED(IDC_BUTTON1, OnButton1)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

BEGIN_DISPATCH_MAP(CDlg_NewRubr, CDialog)
	//{{AFX_DISPATCH_MAP(CDlg_NewRubr)
		// NOTE - the ClassWizard will add and remove mapping macros here.
	//}}AFX_DISPATCH_MAP
END_DISPATCH_MAP()

// Note: we add support for IID_IDlg_NewRubr to support typesafe binding
//  from VBA.  This IID must match the GUID that is attached to the 
//  dispinterface in the .ODL file.

// {8C764D4B-561F-4AC8-8B37-B5A96E16B35C}
static const IID IID_IDlg_NewRubr =
{ 0x8c764d4b, 0x561f, 0x4ac8, { 0x8b, 0x37, 0xb5, 0xa9, 0x6e, 0x16, 0xb3, 0x5c } };

BEGIN_INTERFACE_MAP(CDlg_NewRubr, CDialog)
	INTERFACE_PART(CDlg_NewRubr, IID_IDlg_NewRubr, Dispatch)
END_INTERFACE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDlg_NewRubr message handlers

// 
void CDlg_NewRubr::OnButton1() 
{
	char szWorkDir[MAX_PATH];
	char sz[MAX_PATH];

	HWND hwnd=HWND();

	BROWSEINFO bi= {hwnd,  // 
		NULL,
		(LPSTR)szWorkDir,  // 
		"Please, choose the folder...",  //                       
		BIF_DONTGOBELOWDOMAIN | BIF_RETURNONLYFSDIRS | BIF_EDITBOX | BIF_BROWSEFORCOMPUTER,  // 
		0,  // -  
		NULL, //    
		0}; //    

	LPCITEMIDLIST lpItemDList;

	if(!(lpItemDList=SHBrowseForFolder(&bi)))
	{
		// -  !
	}
	//    
	SHGetPathFromIDList(lpItemDList, sz); // sz - ,   ...
	
	CString y;
	y.Format("%s", sz);
	if (y!="")	SetDlgItemText(IDC_EDIT2, y);

//	SetFocus(hwnd);
}

void CDlg_NewRubr::OnOK() 
{
	CString y;
	UpdateData(true);
	
	if (m_edit1=="") AfxMessageBox("   \" \"");
	else if (m_edit2=="")	AfxMessageBox("   ");
	else
	{
		
		DWORD d; d = CreateDirectory(m_edit2, (LPSECURITY_ATTRIBUTES)NULL);
		
		if (!d)
		{
			d = GetLastError();
			if (d != 183)
			{
				CString y;
				y.Format("    \"%s\"!",m_edit2);
				AfxMessageBox(y);
			}
			else	
			{
				RR.B.rubriks[RR.B.numR].dir=m_edit2;
				RR.B.rubriks[RR.B.numR].name=m_edit1;
				RR.B.rubriks[RR.B.numR].numK = 0;

				RR.B.numR++;

				RR.SaveSettings("settings.dat");	
				AfxMessageBox(" !");
				
				RR.tmpID=-2;

				CDialog::OnOK();
			}
		}
		
		
	}
}
